import QtQuick 2.0
import QtQml 2.12
import QtQuick.Layouts 1.12
import org.ukui.qqc2style.private 1.0 as StylePrivate
import "."

Rectangle {
    property string timeformat: trayIcon.timeformat;
    property string hour;
    property string minute;
    property int hournumber;
    property string week;
    property string dateformat: trayIcon.dateformat

    width: 53 * Style.tabletScaleFactor
    height: 54 * Style.tabletScaleFactor
    color: "transparent"

    Timer {
        id: gettime;
        interval: 100;
        running: true;
        repeat: true;
        triggeredOnStart: true
        onTriggered: {
            hour = Qt.formatTime(new Date(),"hh");
            minute = Qt.formatTime(new Date(),"mm");
            if(timeformat === "12") {
                hournumber = Number(hour);
                if(hournumber > 12) {
                    hournumber -= 12;
                    hour = hournumber.toString();
                }
                time.text = hour + ":" + minute
            }
            else {
                time.text = hour + ":" + minute
            }
            week.text = Qt.formatDate(new Date(),"ddd")
            if(dateformat == "cn") {
                date.text = Qt.formatDate(new Date(),"MM/dd");
            }
            if(dateformat == "en") {
                date.text = Qt.formatDate(new Date(),"MM-dd");
            }
        }
    }

    Column {
        anchors.centerIn: parent
        anchors.horizontalCenter: parent.horizontalCenter
        spacing: -4 * Style.tabletScaleFactor
        Text {
            id: time
            color: "#262626"; font.pointSize: 16
            font.family: StylePrivate.StyleHelper.font.family
            font.styleName: StylePrivate.StyleHelper.font.styleName
        }
        Row {
            spacing: 2 * Style.tabletScaleFactor
            Text {
                id: date
                color: "#000000"; font.pointSize: 8
                font.family: StylePrivate.StyleHelper.font.family
                font.styleName: StylePrivate.StyleHelper.font.styleName
            }
            Text {
                id: week
                color: "#000000"; font.pointSize: 8
                font.family: StylePrivate.StyleHelper.font.family
                font.styleName: StylePrivate.StyleHelper.font.styleName
            }
        }
    }

    Component.onCompleted: gettime.start();
}
