function appItemPositionChanged(mouseArea, pageChangeTimer, toDesktopTimer, appIconItem, appIconItemRoot,
                                popupGroupContainer, popupGroupContainerId) {
    if (mouseArea.Drag.active && !mouseArea.groupHeightChanged &&
            (appIconItemRoot.x - mouseArea.startDragPoint.x > 0
             || appIconItemRoot.y - mouseArea.startDragPoint.y > 0)) {
        changeGroupHeight()
        mouseArea.groupHeightChanged = true
    }

    if (allowGroupItemToTaskbar) {
        appIconItem.iconWidth = 64 * Style.tabletScaleFactor
    }

    if (!allowGroupItemToTaskbar && itemRoot.Drag.active) {
        appIconItem.iconWidth = 96 * Style.tabletScaleFactor * 1.1
    }
    if (!GroupController.groupPopuped) {
        return
    }

    var itemPos = appIconItem.mapToItem(popupGroupContainer, 0, 0)
    if (itemPos.x % popupGroupContainer.width < -appIconItem.width ||
                itemPos.x > popupGroupContainer.width ||
                itemPos.y % popupGroupContainer.height < -appIconItem.height ||
                itemPos.y > popupGroupContainer.height) {
        pageChangeTimer.stop()
        mouseArea.isChangeListviewPage = false
        if (GroupController.groupPopuped) {
            toDesktopTimer.start()
        }
    } else if ((itemPos.x % popupGroupContainer.width) >= (popupGroupContainer.width - appIconItem.width + 32 * Style.tabletScaleFactor) &&
            mouseArea.Drag.active) {
        pageChangeTimer.start()
        toDesktopTimer.stop()
        if (mouseArea.isChangeListviewPage) {
            if (popupGroupContainer.currentIndex < popupGroupContainer.count - 1) {
                popupGroupContainer.currentIndex ++
                modelManager.removePlaceholderItem()
                // 拖动至不同页时才添加 placeholder item
                if ((mouseArea.drag.target.groupId === popupGroupContainerId &&
                     mouseArea.drag.target.pageIndex !== popupGroupContainer.currentIndex) ||
                        mouseArea.drag.target.groupId !== popupGroupContainerId)  {
                    if (popupGroupContainer.currentIndex === -1) {
                        return
                    }
                    var groupCurItemCount = modelManager.groupPageItemCount(popupGroupContainerId, popupGroupContainer.currentIndex)
                    var index = groupCurItemCount > 0 ? groupCurItemCount : 0
                    modelManager.addPlaceholderItem(index, popupGroupContainer.currentIndex, mouseArea.drag.target.rowSpan,
                                mouseArea.drag.target.columnSpan, popupGroupContainerId)
                }
                mouseArea.isChangeListviewPage = false
                pageChangeTimer.restart()
            } else {
                appIconItem.x = 0
            }
        }
    } else if ((itemPos.x % popupGroupContainer.width < -32 * Style.tabletScaleFactor) &&
               mouseArea.Drag.active) {
        pageChangeTimer.start()
        toDesktopTimer.stop()
        if (mouseArea.isChangeListviewPage && popupGroupContainer.currentIndex > 0) {
            popupGroupContainer.currentIndex --
            modelManager.removePlaceholderItem()
            if ((mouseArea.drag.target.groupId === popupGroupContainerId &&
                 mouseArea.drag.target.pageIndex !== popupGroupContainer.currentIndex) ||
                    mouseArea.drag.target.groupId !== popupGroupContainerId)  {
                if (popupGroupContainer.currentIndex === -1) {
                    return
                }
                groupCurItemCount = modelManager.groupPageItemCount(popupGroupContainerId, popupGroupContainer.currentIndex)
                index = groupCurItemCount > 0 ? groupCurItemCount : 0
                modelManager.addPlaceholderItem(index, popupGroupContainer.currentIndex, mouseArea.drag.target.rowSpan,
                            mouseArea.drag.target.columnSpan, popupGroupContainerId)

            }
            mouseArea.isChangeListviewPage = false
            pageChangeTimer.restart()
        }
    } else {
        pageChangeTimer.stop()
        toDesktopTimer.stop()
        mouseArea.isChangeListviewPage = false
    }
}
